﻿using C1.WPF.Grid;
using System.Collections.ObjectModel;
using System.Dynamic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace DynamicBinding
{
    public partial class MainWindow : Window
    {
        private string _headerText;

        public string HeaderText
        {
            get { return _headerText; }
            set { _headerText = value; }
        }

        private ObservableCollection<Person> _persons;

        public ObservableCollection<Person> Persons
        {
            get { return _persons; }
            set { _persons = value; }
        }

        public MainWindow()
        {
            InitializeComponent();

            Persons = new ObservableCollection<Person>();
            
            var employee1 = new Person();
            employee1.Name = "John";
            employee1.Age = 18;
            
            var employee2 = new Person();
            employee2.Name = "Paul";
            employee2.Age = 22;
            employee2.Instrument = "Guitar";

            var employee3 = new Person();
            employee3.Name = "Ringo";
            employee3.Instrument = "Drums";

            var employee4 = new Person();
            employee4.Name = "George";
            employee4.Age = 23;

            Persons.Add(employee1);
            Persons.Add(employee2);
            Persons.Add(employee3);
            Persons.Add(employee4);

            HeaderText = "Custom Name";
            grid.ItemsSource = Persons;
            grid.CellFactory = new CustomCellFactory();
            this.DataContext= this;
        }

    }

    public class Person
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public string Instrument { get; set; }
    }

    public class CustomCellFactory : GridCellFactory
    {
        public override void BindCellContent(GridCellType cellType, GridCellRange range, FrameworkElement cellContent)
        {
            base.BindCellContent(cellType, range, cellContent);
            if (cellType == GridCellType.ColumnHeader & range.Column == 0)
            {
                var s =cellContent;
                Binding binding = new Binding("HeaderText");
                cellContent.SetBinding(GridColumnHeaderCell.TitleProperty, binding);
            }
        }
    }
}


